﻿using HandyControl.Tools.Extension;
using HandyControl.Tools;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using HandyControl.Controls;
using System.Reflection.Metadata;

namespace DyuClient.ViewPages.Main;
/// <summary>
/// MainWindowContent.xaml 的交互逻辑
/// </summary>
public partial class MainWindowContent {

    private GridLength _columnDefinitionWidth;

    public MainWindowContent() {
        InitializeComponent();
       
    } 
    
    /// <summary>
    /// 重新加载菜单文字，根据当前应用程序资源设置菜单项的Header属性
    /// </summary>
    public void ReloadMenuText()
    {
        // 遍历sideMenu中的每个顶级菜单项
        foreach (var topMenuItem in sideMenu.Items)
        {
            if (topMenuItem is SideMenuItem smiTop)
            {
                // 设置顶级菜单项的Header
                var topMenuHeaderText = Application.Current.TryFindResource(smiTop.Tag.ToString() + "TopMenuHeader") as string?? smiTop.Header.ToString();
                smiTop.Header = topMenuHeaderText;

                // 遍历顶级菜单项的子菜单项并设置Header
                foreach (var subMenuItem in smiTop.Items)
                {
                    if (subMenuItem is SideMenuItem smiSub)
                    {
                        var menuName = Application.Current.TryFindResource(smiSub.Tag.ToString()) as string?? "Default Message";
                        if (menuName != "Default Message")
                        {
                            var subMenuHeaderText = Application.Current.TryFindResource(smiSub.Tag.ToString() + "SubMenuHeader") as string?? menuName;
                            smiSub.Header = subMenuHeaderText;
                            
                        }
                    }
                }
            }
        }
    }
    private void Border_Initialized(object sender, EventArgs e) {
        sideMenu.Items.Clear();
        SideMenuItem smiTop1 = new SideMenuItem();
        smiTop1.Icon = new System.Windows.Controls.Image() {
            Source = new BitmapImage(new Uri("pack://application:,,,/Resource/Image/MenuIcon/app.png")),
            Width = 24, Height = 24
        };
        smiTop1.Header = "演示";
        smiTop1.Tag = "Demo";

        SideMenuItem smiTopMenu1 = new SideMenuItem();
        smiTopMenu1.Icon = new System.Windows.Controls.Image() {
            Source = new BitmapImage(new Uri("pack://application:,,,/Resource/Image/MenuIcon/app.png")),
            Width = 24,
            Height = 24
        };
        smiTopMenu1.Header = "演示1";
        smiTopMenu1.Tag = "Demo1";

        SideMenuItem smiTopMenu2 = new SideMenuItem();
        smiTopMenu2.Icon = new System.Windows.Controls.Image() {
            Source = new BitmapImage(new Uri("pack://application:,,,/Resource/Image/MenuIcon/app.png")),
            Width = 24,
            Height = 24
        };
        
        var message = Application.Current.TryFindResource("Demo2") as string?? "Default Message";
        smiTopMenu2.Header = message;
        smiTopMenu2.Tag = "Demo2";


        SideMenuItem smiTopMenu3 = new SideMenuItem();
        smiTopMenu3.Icon = new System.Windows.Controls.Image() {
            Source = new BitmapImage(new Uri("pack://application:,,,/Resource/Image/MenuIcon/app.png")),
            Width = 24,
            Height = 24
        };
        smiTopMenu3.Header = "Http接口";
        smiTopMenu3.Tag = "Demo3";
        
        SideMenuItem smiTopMenu4 = new SideMenuItem();
        smiTopMenu4.Icon = new System.Windows.Controls.Image() {
            Source = new BitmapImage(new Uri("pack://application:,,,/Resource/Image/MenuIcon/app.png")),
            Width = 24,
            Height = 24
        };
        smiTopMenu4.Header = "模型面点击";
        smiTopMenu4.Tag = "Demo4";

        smiTop1.Items.Add(smiTopMenu1);
        smiTop1.Items.Add(smiTopMenu2);
        smiTop1.Items.Add(smiTopMenu3);
        smiTop1.Items.Add(smiTopMenu4);
        sideMenu.Items.Add(smiTop1);
    }

    private void sideMenu_SelectionChanged(object sender, HandyControl.Data.FunctionEventArgs<object> e) {

        if (e.Info is SideMenuItem selItem) {
            if (selItem == null || selItem.Tag == null)
                return;
            String pageName = selItem.Tag.ToString();
            var existingTab = tabControl.Items.OfType<TabItem>().FirstOrDefault(t => t.Tag.ToString() == pageName);
            if (existingTab == null) {
                var newTab = new TabItem {
                    Header = selItem.Header,
                    Content = Activator.CreateInstance(Type.GetType($"DyuClient.ViewPages.TabPages.{pageName}")),
                    IsSelected = true,
                    ShowCloseButton = true,
                    Tag = pageName,
                };
                tabControl.Items.Add(newTab);
            } else {
                existingTab.IsSelected = true;
            }
        }
    }
}

